/*
   Copyright (C) 2024 Michael Nelson Moran

   This file is part of OSCL.

   OSCL is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   OSCL is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with OSCL; see the file COPYING.  If not, write to the Free
   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To negotiate other licensing arrangements/agreements contact
   the copyright holder:

   Michael N. Moran
   218 Wilshire Terrace       mike@mnmoran.org
   White, GA, USA 30184       http://mnmoran.org
*/

#include "driver.h"
#include <stdio.h>
#include "oscl/hw/arm/cortexm7/nvic.h"
#include "oscl/driver/cortexm/asm.h"

using namespace Oscl::St::Stm32::H7::I2C::Master::Server;

Driver::Driver(
	Oscl::St::Stm32::H7::pI2C::Map&	map,
	unsigned						interruptNumber
	) noexcept:
		_map(map),
		_interruptNumber(interruptNumber),
		_interrupt(
			map,
			*this
			),
		_sync(
			*this,
			*this
			),
		_readMsg(0),
		_writeMsg(0),
		_currentData(0),
		_currentRemaining(0),
		_read(true),
		_count(0)
		{
	}

void Driver::initialize() noexcept{
	using namespace Oscl::St::Stm32::H7::pI2C;

	auto
	cr1	= _map.cr1;
	cr1	&= ~(
			0
		|	rCR1::fPE::FieldMask
		|	rCR1::fTXIE::FieldMask
		|	rCR1::fRXIE::FieldMask
		|	rCR1::fADDRIE::FieldMask
		|	rCR1::fNACKIE::FieldMask
		|	rCR1::fSTOPIE::FieldMask
		|	rCR1::fTCIE::FieldMask
		|	rCR1::fERRIE::FieldMask
		|	rCR1::fDNF::FieldMask
		|	rCR1::fANFOFF::FieldMask
		|	rCR1::fTXDMAEN::FieldMask
		|	rCR1::fRXDMAEN::FieldMask
		|	rCR1::fSBC::FieldMask
		|	rCR1::fNOSTRETCH::FieldMask
		|	rCR1::fWUPEN::FieldMask
		|	rCR1::fGCEN::FieldMask
		|	rCR1::fSMBHEN::FieldMask
		|	rCR1::fSMBDEN::FieldMask
		|	rCR1::fALERTEN::FieldMask
		|	rCR1::fPECEN::FieldMask
		);
	cr1	|=
			0
		|	rCR1::fPE::ValueMask_enable
		|	rCR1::fTXIE::ValueMask_enable
		|	rCR1::fRXIE::ValueMask_enable
		|	rCR1::fADDRIE::ValueMask_disable
		|	rCR1::fNACKIE::ValueMask_disable
		|	rCR1::fSTOPIE::ValueMask_enable // really?
		|	rCR1::fTCIE::ValueMask_enable
		|	rCR1::fERRIE::ValueMask_disable
		|	rCR1::fDNF::ValueMask_disable
		|	rCR1::fANFOFF::ValueMask_disable
		|	rCR1::fTXDMAEN::ValueMask_disable
		|	rCR1::fRXDMAEN::ValueMask_disable
		|	rCR1::fSBC::ValueMask_disable
		|	rCR1::fNOSTRETCH::ValueMask_disable
		|	rCR1::fWUPEN::ValueMask_disable
		|	rCR1::fGCEN::ValueMask_disable
		|	rCR1::fSMBHEN::ValueMask_disable
		|	rCR1::fSMBDEN::ValueMask_disable
		|	rCR1::fALERTEN::ValueMask_disable
		|	rCR1::fPECEN::ValueMask_disable
		;
	_map.cr1	= cr1;

	}

void	Driver::processNextPending() noexcept{
	Oscl::Mt::Itc::Msg*
	msg	= _pendingQ.get();
	if( msg ) {
		msg->process();
		}
	}

void	Driver::mboxSignaled() noexcept{
	++_count;

	using namespace Oscl::St::Stm32::H7::pI2C;
	auto
	isrerr = _map.isr;

	isrerr	&= (
			0
//		|	rISR::fADDR::FieldMask	// slave mode
		|	rISR::fNACKF::FieldMask	// NACK received. Restart transaction or report error?
		|	rISR::fSTOPF::FieldMask	// If STOP is generated by peripheral (which should NOT happen )
//		|	rISR::fTC::FieldMask	// Currently not used. Using rCR2::fAUTOEND::ValueMask_afterTransferSTOP == 1
//		|	rISR::fTCR::FieldMask	// Currently not used. Using rCR2::fRELOAD::ValueMask_transferThenStopOrRestart == 0
		|	rISR::fBERR::FieldMask	// Bus error. Restart transaction or report error?
		|	rISR::fARLO::FieldMask	// Arbitration loss. Restart transaction or report error?
//		|	rISR::fOVR::FieldMask	// slave mode
//		|	rISR::fPECERR::FieldMask	// SMBus
//		|	rISR::fTIMEOUT::FieldMask	// SMBus
//		|	rISR::fALERT::FieldMask	// SMBus
//		|	rISR::fBUSY::FieldMask
//		|	rISR::fDIR::FieldMask	// slave mode
//		|	rISR::fADDCODE::FieldMask	// slave mode
		);

	// The ISR and ICR bit positions are identical
	// Clear/acknowledge errors
	_map.icr	= isrerr;

	// READ
	if( _readMsg ) {
		while( (_map.isr & rISR::fRXNE::FieldMask) == rISR::fRXNE::ValueMask_notEmpty ) {
			*_currentData	= _map.rxdr;

			++_currentData;
			--_currentRemaining;

			if(!_currentRemaining){
				if(_readMsg){
					_readMsg->_payload._failed	= false;
					_readMsg->returnToSender();
					_readMsg	= 0;
					processNextPending();
					return;
					}
				}
			}
		Oscl::Arm::CortexM7::pNVIC::enableInterrupt( _interruptNumber );
		return;
		}

	if( _writeMsg ) {
		while( (_map.isr & rISR::fTXE::FieldMask) == rISR::fTXE::ValueMask_empty ) {
			_map.txdr	= *_currentData;
			++_currentData;
			--_currentRemaining;
			if(_currentRemaining == 0){
				if(_writeMsg){
					_writeMsg->_payload._failed	= false;
					_writeMsg->returnToSender();
					_writeMsg	= 0;
					processNextPending();
					return;
					}
				}
			}
		Oscl::Arm::CortexM7::pNVIC::enableInterrupt( _interruptNumber );
		return;
		}

//	Oscl::Arm::CortexM7::pNVIC::enableInterrupt( _interuptNumber );
	}

Oscl::Interrupt::StatusHandlerApi&	Driver::getISR() noexcept{
	return _interrupt;
	}

Oscl::Interrupt::IsrDsrApi&	Driver::getIsrDsr() noexcept{
	return _interrupt;
	}

Oscl::Mt::Runnable&	Driver::getRunnable() noexcept{
	return *this;
	}

Oscl::I2C::Master::SevenBit::Req::Api::SAP& Driver::getSevenBitSAP() noexcept{
	return _sync.getSAP();
	}

Oscl::I2C::Master::SevenBit::Api&	Driver::getSevenBitSyncApi() noexcept{
	return _sync;
	}

void	Driver::syncOpen() noexcept{
	}

void	Driver::syncClose() noexcept{
	}

void	Driver::request(Oscl::I2C::Master::SevenBit::Req::Api::ReadReq& msg) noexcept{
	if( _pendingQ.first() ){
		_pendingQ.put(&msg);
		return;
		}

	if( _writeMsg || _readMsg ) {
		_pendingQ.put(&msg);
		return;
		}

	using namespace Oscl::St::Stm32::H7::pI2C;

	_currentRemaining	= msg._payload._nDataBytesToRead;

	if( !_currentRemaining ) {
		msg._payload._failed	= true;
		msg.returnToSender();
		return;
		}

	_count	= 0;
	_readMsg	= &msg;
	_currentData		= (unsigned char*)msg._payload._dataBuffer;

	while( (_map.isr & rISR::fBUSY::FieldMask) == rISR::fBUSY::ValueMask_busy );

	auto
	cr2	= _map.cr2;
	cr2	&= ~(
			0
		|	rCR2::fSADD::FieldMask
		|	rCR2::fRD_WRN::FieldMask
		|	rCR2::fADD10::FieldMask
		|	rCR2::fHEAD10R::FieldMask
		|	rCR2::fSTART::FieldMask
		|	rCR2::fSTOP::FieldMask
		|	rCR2::fNACK::FieldMask
		|	rCR2::fNBYTES::FieldMask
		|	rCR2::fRELOAD::FieldMask
		|	rCR2::fAUTOEND::FieldMask
		|	rCR2::fPECBYTE::FieldMask
		);
	uint32_t	address	= msg._payload._address;
	uint32_t	slaveAddress	= address << 1;
	uint32_t	nbytes = msg._payload._nDataBytesToRead;

	// As master, this will attempt a 1 byte READ from a slave
	cr2	|=
			0
		|	( slaveAddress << rCR2::fSADD::Lsb )
		|	rCR2::fRD_WRN::ValueMask_readTransfer
		|	rCR2::fADD10::ValueMask_sevenBitAddressMode
		|	rCR2::fHEAD10R::ValueMask_masterSendsFirstSevenBits
		|	rCR2::fSTART::ValueMask_startRestartGeneration
		|	rCR2::fSTOP::ValueMask_noEffect
		|	rCR2::fNACK::ValueMask_noEffect
		|	( nbytes << rCR2::fNBYTES::Lsb )
		|	rCR2::fRELOAD::ValueMask_transferThenStopOrRestart
		|	rCR2::fAUTOEND::ValueMask_afterTransferSTOP
		|	rCR2::fPECBYTE::ValueMask_noPacketErrorXfer
		;

	_map.cr2	= cr2;

	Oscl::Arm::CortexM7::pNVIC::enableInterrupt( _interruptNumber );
	}

void	Driver::request(Oscl::I2C::Master::SevenBit::Req::Api::CancelReadReq& msg) noexcept{
	}

void	Driver::request(Oscl::I2C::Master::SevenBit::Req::Api::WriteReq& msg) noexcept{
	if( _pendingQ.first() ){
		_pendingQ.put(&msg);
		return;
		}

	if( _writeMsg || _readMsg ) {
		_pendingQ.put(&msg);
		return;
		}

	using namespace Oscl::St::Stm32::H7::pI2C;

	_count	= 0;
	_writeMsg	= &msg;
	_currentData		= (unsigned char*)msg._payload._data;
	_currentRemaining	= msg._payload._nDataBytes;

	while( (_map.isr & rISR::fBUSY::FieldMask) == rISR::fBUSY::ValueMask_busy );

	auto
	cr2	= _map.cr2;
	cr2	&= ~(
			0
		|	rCR2::fSADD::FieldMask
		|	rCR2::fRD_WRN::FieldMask
		|	rCR2::fADD10::FieldMask
		|	rCR2::fHEAD10R::FieldMask
		|	rCR2::fSTART::FieldMask
		|	rCR2::fSTOP::FieldMask
		|	rCR2::fNACK::FieldMask
		|	rCR2::fNBYTES::FieldMask
		|	rCR2::fRELOAD::FieldMask
		|	rCR2::fAUTOEND::FieldMask
		|	rCR2::fPECBYTE::FieldMask
		);
	uint32_t	address	= msg._payload._address;
	uint32_t	slaveAddress	= address << 1;
	uint32_t	nbytes = msg._payload._nDataBytes;

	cr2	|=
			0
		|	( slaveAddress << rCR2::fSADD::Lsb )
		|	rCR2::fRD_WRN::ValueMask_writeTransfer
		|	rCR2::fADD10::ValueMask_sevenBitAddressMode
		|	rCR2::fHEAD10R::ValueMask_masterSendsFirstSevenBits
		|	rCR2::fSTART::ValueMask_startRestartGeneration
		|	rCR2::fSTOP::ValueMask_noEffect
		|	rCR2::fNACK::ValueMask_noEffect
		|	( nbytes << rCR2::fNBYTES::Lsb )
		|	rCR2::fRELOAD::ValueMask_transferThenStopOrRestart
		|	rCR2::fAUTOEND::ValueMask_afterTransferSTOP
		|	rCR2::fPECBYTE::ValueMask_noPacketErrorXfer
		;
	_map.cr2	= cr2;

	Oscl::Arm::CortexM7::pNVIC::enableInterrupt( _interruptNumber );
	}

void	Driver::request(Oscl::I2C::Master::SevenBit::Req::Api::CancelWriteReq& msg) noexcept{
	}

